#!/bin/sh
#
# This is a driver installer for TouchKit controller.
#
# Version: 1.05.2407
# Released: 2009/12/07
#

version="1.00"
trash="/dev/null"
paramfile="/etc"
xmodulespath="/usr/X11R6/lib/modules/input"
xmodulespath2="/usr/lib/xorg/modules/input"
driver="unichip_drv.so "
driverpath="/unichip/moudle"
installpath="/"
identifier="TouchScreen"
#shortcutpath="/usr/bin"
xfilepath="/etc/X11/xorg.conf"
xfilepath2="/etc/X11/XF86Config-4"
xfilepath3="/etc/X11/XF86Config"
rclocalpath="/etc/rc.local"
xorgpath3="/usr/lib/X11/xorg.conf.d" # for Ubuntu 10.04 and Meego 1.0 netbook
xorgpath2="/usr/share/X11/xorg.conf.d" # for Fedora 13/14 & Ubuntu 10.10
xorgpath="/etc/X11/xorg.conf.d"
xorgfile="60-unichip.conf" # for Ubuntu 10.04 & Meego 1.0

ShowTitle() {
    echo ""
    echo "(*) Linux driver installer for UniChip controller "
    echo ""
}

CheckPermission() {
    echo -n "(I) Check user permission:"
    account=`whoami`
    if [ ${account} = "root" ]; then
        echo " ${account}, you are the supervisor."
    else
        echo " ${account}, you are not the supervisor."
        echo "(E) The root permission is required to run this installer."
        echo ""
        exit 1
    fi
}
RemoveDriver() {
	if [ -e  "/etc/tpaneld.conf" ];then
     		rm -f /etc/tpaneld.conf
   	fi

	if [ -e  "/etc/cal.conf" ];then
     		rm -f /etc/cal.conf
  	 fi

	if [ -e /unichip ];then
		rm -r -f /unichip
	fi
	sed -i '/### unichip Configuration Beginning ###/,/### Touch Configuration End ###/d' ${rclocalpath}
	
    pidlist=`ps -ef|grep UcDriver| grep -v "grep"|awk '{print $2}'`
    if [ "$pidlist" = "" ]
    then
    {
	echo ""	
    }
    else
    for pid in ${pidlist}
    do
    kill -9 $pid

    done
    fi
}


RemoveXorgModule() {
    xmodule=$driver
    if [ -e ${xmodulespath}/${xmodule} ]; then
        rm -f ${xmodulespath}/${xmodule}
    elif [ -e ${xmodulespath2}/${xmodule} ]; then
        rm -f ${xmodulespath2}/${xmodule}
    else
        echo "(I) Searching the X module of touch device."
        fullmodulepath=`find /usr -name ${xmodule}`
        if [ -z "${fullmodulepath}" ]; then
            RemoveDriver
            echo "(E) No X module of touch device found."
            echo ""
            exit 1
        elif [ -e ${fullmodulepath} ]; then
            rm -f ${fullmodulepath}
        fi
    fi
    echo "(I) Removed X module."
}


RemoveConfiguration() {
    sed -i '/"'${identifier}'" "SendCoreEvents"/d' $1
    sed -i '/### Touch Configuration Beginning ###/,/### Touch Configuration End ###/d' $1
    echo "(I) Removed touch configuration from $1."
}

RestoreConfigFile() {
    if [ -w ${xfilepath} ]; then
        RemoveConfiguration ${xfilepath}
    elif [ -w ${xfilepath2} ]; then
        RemoveConfiguration ${xfilepath2}
    elif [ -w ${xfilepath3} ]; then
        RemoveConfiguration ${xfilepath3}
    else

	 if [ -e ${xorgpath}/60-unichip.conf ]; then
		rm    ${xorgpath}/60-unichip.conf
    	 fi
    	 if  [ -e ${xorgpath2}/60-unichip.conf ]; then
		rm ${xorgpath2}/60-unichip.conf 
  	 fi 
   	 if [ -e ${xorgpath3}/60-unichip.conf ]; then
		rm  ${xorgpath3}/60-unichip.conf  
   	 fi

        echo "(E) Remove X configuration file ."
        echo ""
        exit 1
    fi
}

clear
ShowTitle

        CheckPermission
        echo "(I) Begin to remove UniChip driver."
        RemoveDriver
        RemoveXorgModule
        RestoreConfigFile
        echo ""
        echo "(I) The UniChip driver has been removed successfully."
        echo "(I) Please reboot the system or Xwindow for some changes to take effect."


echo ""
